package model;

public class RecursiveMethods {
	/*
	 * Return the number of ways for climbing a staircase
	 * 	with height of `h` steps, subject to the rule that
	 * 	each climb can take up to `n` steps.
	 */
	public int climb(int h, int n) {
		if(h < 0) {
			// the last step climbed goes beyond the top of the staircase
			return 0;
		}
		else if(h == 0) {
			// the last step climbed reached the top of the staircase
			return 1;
		}
		else { /* more steps to climb */
			int possible = 0;
			/* try out all possible steps to climb first, then 
			 * let a recursive call handle the reaming steps. */
			for(int i = 1; i <= n; i ++) {
				// Climb i steps, and let recursion handle the remaining h - i steps.
				possible += climb(h - i, n);
			}
			return possible;
		}
	}
}
 